<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Curse of Dimensionality</title>
    <link rel="stylesheet" href="../Css/styles.css">
    <link rel="stylesheet" id="themeStylesheet" href="../Css/light-theme.css"> <!-- thème clair par défaut -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0/css/all.min.css">
</head>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jsxgraph/1.3.5/jsxgraphcore.js"></script>
<script src="https://cdn.jsdelivr.net/npm/jsxgraph@1.3.5/dist/jsxgraphcore.js"></script>
<script src="https://d3js.org/d3.v6.min.js"></script>
<script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
<script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
<script src="https://d3js.org/d3.v7.min.js"></script>



<body>

    <section class="top-page">
        <header class="header">
            <nav class="nav">
                <li><a href="#intro">Introduction</a></li>
                <li><a href="#demo">Interactive Demo</a></li>
                <li><a href="#res">Resources</a></li>
            </nav>
            <button id="themeSwitch">Switch Theme</button> <!-- Bouton pour basculer entre les thèmes -->
            
        </header>
        <select id="langSelect"> <!-- Bouton language -->
            <option value="en">English</option>
            <option value="fr">Français</option>
        </select>
        
        <div class="landing-page">
            <h1 class="big-title">Curse of Dimensionality</h1>
            <a class="scroll-down" href="#end">Scroll <i class="fas fa-angle-down"></i></a>
        </div>

    </section>

    <section class="intro" id="intro">
        <h2 class="section-title">Introduction</h2>

        <p class="text">
            The "Curse of Dimensionality" is a complex phenomenon that affects the performance of machine learning and data mining algorithms when faced with high-dimensional datasets. This concept is essential for understanding the challenges faced by data scientists and machine learning engineers when working with large datasets.
        </p>
        <h3 class="text-title">What is Dimensionality ?</h3>
        <p class="text">
            The dimensionality of a dataset refers to the number of features or variables that compose it. For example, in a two-dimensional dataset, each data point is defined by two variables (or dimensions). As the number of dimensions increases, the space in which the data resides becomes vast and complex.
        </p>
        <h3 class="text-title">The Curse of Dimensionality</h3>
        <p class="text">
            The Curse of Dimensionality describes the negative phenomena that occur when the number of dimensions in a dataset becomes very high. These phenomena include increased data sparsity, increased distance between data points, and increased complexity of models needed to effectively process them.
        </p>
        <h3 class="text-title">Consequences and Challenges</h3>
        <p class="text">
            The Curse of Dimensionality presents several important consequences and challenges for practical applications in data science:
        </p>
        <p class="text-list">
            It can lead to increased computation time required for model training.
        </p>
        <p class="text-list">
            It may require much larger datasets to achieve reliable modeling performance.
        </p>
        <p class="text-list">
            It can result in poor model generalization, due to overfitting or underfitting to the data.
        </p>
        <p class="text">
            Understanding these challenges is crucial for developing effective solutions and data preprocessing techniques to overcome the Curse of Dimensionality and improve the performance of machine learning algorithms.
        </p>


    </section>

    <section class="demo" id="demo">
        <h2 class="section-title">Interactive Demo</h2>

        <div class="text">
            <p>
                Below, you will find an interactive demonstration to visualize concepts related to the Curse of Dimensionality. Here's an explanation of how it works:
            </p>
        </div>
        <div class="text">
            <h3>1. Parameter Selection:</h3>
            <ul>
                <li>
                    <strong>1. Number of dimensions:</strong> The number of dimensions of the hypercube is defined using the "Dimension" slider. Thus, the number of corners of the hypercube will be 2^dim corners. Note that, due to display issues, only a certain number of outer corners will be sampled, resulting in the number of samples being << 2^dim.
                    See the mathematical explanation and algorithm principle section for more details.
                </li>
                <li>
                    <strong>2. Number of samples:</strong> The number of samples in the display is also defined by entering it in the "Number of samples" bar, which determines the number of sample corners generated in the space between the circumscribed and inscribed circles (we will start by displaying the outermost corners). Note that the number of samples must be << 2^dim.
                </li>
                <li>
                    <strong>3. Vector w:</strong> The vector w from which the projection plane by Gram-Schmidt will be constructed is selectable using the "w" dropdown menu.
                    See the mathematical explanation and algorithm principle section for more details.
                </li>
            </ul>
        </div>
        <div class="text">
            <h3>2. Point Generation:</h3>
            <p class="text">
                When you adjust the sliders to choose the desired parameters, points are generated randomly in the multidimensional hypercube based on the values selected with the "Number of points" slider. Once the projection onto the plane is done, you will notice that the points are located inside the circumscribed circle.
                See the mathematical explanation and algorithm principle section for more details.
            </p>
        </div>
        <div class="text">
            <h3>3. Norm Histogram:</h3>
            <p class="text">
                A histogram is also generated to display the distribution of norms of the generated random points. You can adjust the number of bars in the histogram using the "Number of bars" slider.
            </p>
        </div>

        <p class="text">
            ______________________________________________
        </p>


        <body>
            <div id="controls">
                <label for="dimension">Dimension:</label>
                <input type="number" id="dimension" value="40" />
                <label for="samples">Number of samples:</label>
                <input type="number" id="samples" value="5000" />
                <label for="NormalVector"><br><br>Choose vector W:</label>
                <div id="NormalVectorCRTL">
                    <label><input type="radio" name="NormalVector" value="random" checked> Random generation</label>
                    <label><input type="radio" name="NormalVector" value="base"> Base vector (1,0,...0)</label>
                    <label><input type="radio" name="NormalVector" value="All 1"> Vector full of 1 (1,1,...1)</label>
                    <label><input type="radio" name="NormalVector" value="manual"> Fill normal vector</label>
                </div>
                <label for="convexHull"><br>Convex hull:</label>
                <div>
                    <label><input type="radio" name="convexHull" value="yes"> Yes</label>
                    <label><input type="radio" name="convexHull" value="no" checked> No</label>
                </div>
                <div id="NormalVectInputs" style="display: none;"></div>
                
                <button id="refreshButton">Generate new points</button>
                <div id="loadingMessage" style="display: none; font-size: 24px;">Please wait...</div>
                <div style="font-size: 15px;"><br>Note: If your number of dimensions is too high, generation may never complete due to algorithm complexity.</div>
            </div>
        <div id="debug"> </div>        
        <div id="graphs-container">
            <div id="graph1" class="jxgbox"></div>
        </div>
        <br>
        <div class="text"id="histogram-container">
            <div id="histogram" class="jxgbox" style="width: 1000px; height: 700px;"></div>
        </div>
        
        <div id="info"></div>
        <script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjs/9.5.0/math.min.js"></script>
        <script>
            document.addEventListener('DOMContentLoaded', function () {
                let currentD, currentN, currentPoints;
        
                function points(Dim, NumberOfPoints) {
                    return Array.from({ length: NumberOfPoints }, () => 
                        Array.from({ length: Dim }, () => Math.random() * 2 - 1)
                    );
                }
        
                function jarvisMarch(points) {
                    const n = points.length;
        
                    if (n < 3) return points;
        
                    let hull = [];
                    // Trouver le point le plus à gauche 
                    let leftmost = points.reduce((leftmost, point, i) => {
                        if (point[0] < points[leftmost][0] || (point[0] === points[leftmost][0] && point[1] < points[leftmost][1])) {
                            return i;
                        }
                        return leftmost;
                    }, 0);
        
                    let p = leftmost, q;
        
                    // Determiner l'orientation + ajout des points de l'enveloppe convexe
                    do {
                        hull.push(points[p]);
                        q = (p + 1) % n;
                        for (let i = 0; i < n; i++) {
                            const orientation = (points[i][1] - points[p][1]) * (points[q][0] - points[i][0]) - (points[i][0] - points[p][0]) * (points[q][1] - points[i][1]);
                            if (orientation > 0 || (orientation === 0 && distance(points[p], points[i]) > distance(points[p], points[q]))) {
                                q = i;
                            }
                        }
                        p = q;
                    } while (p !== leftmost); // Répéter jusqu'à revenir au point de départ
        
                    return hull; // Ensemble de point determinant l'enveloppe convexe
                }

                function debug(message) {
                    document.getElementById("debug").innerHTML = ("Debug: " + message +
                "<br/>");
                }
        
                function distance(p1, p2) {
                    return Math.sqrt((p2[0] - p1[0]) ** 2 + (p2[1] - p1[1]) ** 2);
                }
        
                function signVector(v) {
                    return v.map(val => Math.sign(val));
                }
        
        
                function projectOnPlane(point, plan) {
                    const y1 = math.dot(point, plan[1]);
                    const y2 = math.dot(point, plan[2]);
                    return [y1, y2];
                }
        
                function gramSchmidt(NormalVect, A) {
                    const W = math.multiply(1 / math.norm(NormalVect), NormalVect);
                    let e1 = math.subtract(A[0], math.multiply(math.dot(A[0], W), W));
                    e1 = math.multiply(1 / math.norm(e1), e1);
                    let e2 = math.subtract(A[1], math.multiply(math.dot(A[1], W), W));
                    e2 = math.subtract(e2, math.multiply(math.dot(e2, e1), e1));
                    e2 = math.multiply(1 / math.norm(e2), e2);
                    return [W, e1, e2];
                }

                function norm(vector) {
                    return Math.sqrt(vector.reduce((sum, component) => sum + component * component, 0));
                }

                function addVectors(vector1, vector2) {
                    let result = new Array(vector1.length);
                    for (let i = 0; i < vector1.length; i++) {
                        result[i] = vector1[i] + vector2[i];
                    }
                    return result;
                }
                
                function multiplyVectorByScalar(vector, scalar) {
                    let result = new Array(vector.length);
                    for (let i = 0; i < vector.length; i++) {
                        result[i] = vector[i] * scalar;
                    }
                    return result;
                }

                function outsideSamples(Dim, numSamples, e1, e2) {
                    let samples = new Array(numSamples);
                    
                    for (let i = 0; i < numSamples; i++) { // O(numSamples)
                        const alpha = Math.random() * 2 - 1;
                        const beta = Math.random() * 2 - 1;

                        const e1Alpha = multiplyVectorByScalar(e1, alpha); // O(Dim)
                        const e2Beta = multiplyVectorByScalar(e2, beta); // O(Dim)
                        const v = addVectors(e1Alpha, e2Beta); // O(Dim)
                        
                        const normV = norm(v); // O(Dim)
                        let normalizedV = new Array(Dim);
                        for (let j = 0; j < Dim; j++) { // O(Dim)
                            normalizedV[j] = v[j] / normV;
                        }
                        
                        samples[i] = signVector(normalizedV); // O(Dim)
                    }

                    return samples; //O(numSamples x Dim)
                }
        
                function updateInputs() {
                    const vecteurNormal = document.getElementById('NormalVectInputs');
                    vecteurNormal.innerHTML = '';
                    if (document.querySelector('input[name="NormalVector"]:checked').value === 'manual') {
                        const dim = parseInt(document.getElementById('dimension').value);
                        for (let i = 0; i < dim; i++) {
                            const input = document.createElement('input');
                            input.type = 'number';
                            input.id = 'vectorCoord' + i;
                            input.placeholder = 'Coord ' + (i + 1);
                            input.value = 1;
                            vecteurNormal.appendChild(input);
                        }
                        vecteurNormal.style.display = 'block';
                    }
                }
        
                function getVecteurNormal(dim) {
                    const type = document.querySelector('input[name="NormalVector"]:checked').value;
                    if (type === 'random') {
                        return points(dim, 1)[0];
                    } else if (type === "base") {
                        return Array.from({ length: dim }, (_, i) => (i === 0 ? 1 : 0));
                    } else if (type === "All 1") {
                        return Array.from({ length: dim }, () => 1);
                    } else {
                        return Array.from({ length: dim }, (_, i) => parseFloat(document.getElementById('vectorCoord' + i).value));
                    }
                }
        
                function scatter(Dim, preGeneratedPoints, numSamples, convexHull) {
                    const VectN = getVecteurNormal(Dim);
                    const Plane = gramSchmidt(VectN, points(Dim, 2));
                    const samplesPointsCube = outsideSamples(Dim, numSamples, Plane[1], Plane[2]);
                    const samplesPointsCubeProject = samplesPointsCube.map(point => projectOnPlane(point, Plane));
                    const pointsProject = preGeneratedPoints.map(point => projectOnPlane(point, Plane));
                    let convexHullPoints = [];
                    if (convexHull === 'yes') { // Calcul de l'enveloppe convexe avec l'algo de jarvis si oui
                        const uniqueSamples = [...new Set(samplesPointsCubeProject.map(JSON.stringify))].map(JSON.parse); // On le transforme en ensemble de points unique sans doublons
                        convexHullPoints = jarvisMarch(uniqueSamples);
                    }
                    const data = [
                        {
                            // Plot les points
                            x: pointsProject.map(p => p[0]),
                            y: pointsProject.map(p => p[1]),
                            mode: 'markers',
                            type: 'scatter',
                            name: 'Points',
                            marker: { size: 3, color: 'black' }
                        },
                        {
                            // Plot les coins exterieurs
                            x: samplesPointsCubeProject.map(p => p[0]),
                            y: samplesPointsCubeProject.map(p => p[1]),
                            mode: 'markers',
                            type: 'scatter',
                            name: 'Outside corners',
                            marker: { size: 6, color: 'red' }
                        }
                    ];
                    // Ajouter la trace Enveloppe convexe si nécessaire
                    if (convexHull === 'yes') {
                        data.push({
                            x: convexHullPoints.map(p => p[0]),
                            y: convexHullPoints.map(p => p[1]),
                            mode: 'lines',
                            type: 'scatter',
                            name: 'Convex hull',
                            line: { color: 'pink', width: 2 }
                        });
                    }
        
                    const layout = {
                        autosize: true,
                        title: `Hypercube projection for dimension D= ${Dim} and N= ${preGeneratedPoints.length} points`,
                        xaxis: {
                            title: 'X',
                            scaleanchor: "y",
                            scaleratio: 1,
                            gridwidth: 2
                        },
                        yaxis: {
                            title: 'Y',
                            gridwidth: 2
                        },
                        shapes: [
                            {
                                type: 'circle',
                                xref: 'x',
                                yref: 'y',
                                x0: -1,
                                y0: -1,
                                x1: 1,
                                y1: 1,
                                line: {
                                    color: 'blue',
                                    width: 2
                                }
                            },
                            {
                                type: 'circle',
                                xref: 'x',
                                yref: 'y',
                                x0: -Math.sqrt(Dim),
                                y0: -Math.sqrt(Dim),
                                x1: Math.sqrt(Dim),
                                y1: Math.sqrt(Dim),
                                line: {
                                    color: 'blue',
                                    width: 2
                                }
                            }
                        ],
                        template: 'plotly_dark',
                        legend: {
                            font: {
                                size: 20 
                            }
                        }
                    };
                    
                    
                    plotHistogram(samplesPointsCubeProject, pointsProject, preGeneratedPoints.length);
                    
                    
                    Plotly.react('graph1', data, layout);
                }
        
                function plotHistogram(samplesPointsCubeProject, pointsProject, numSamples) {
                    const data = [
                        {
                            x: pointsProject.map(point => Math.sqrt(point[0]**2 + point[1]**2)),
                            type: 'histogram',
                            name: 'Points',
                            marker: {
                                color: 'black'
                            },
                            opacity: 0.5
                        },
                        {
                            x: samplesPointsCubeProject.map(point => Math.sqrt(point[0]**2 + point[1]**2)),
                            type: 'histogram',
                            name: 'Corners',
                            marker: {
                                color: 'red'
                            },
                            opacity: 0.5
                        }
                    ];
        
                    const layout = {
                        title: 'Histogram of the norm of projected data',
                        xaxis: {
                            title: 'Norms'
                        },
                        yaxis: {
                            title: 'Frequency'
                        },
                        barmode: 'overlay',
                        width: 1000,
                        height: 700
                    };
        
                    Plotly.newPlot('histogram', data, layout);
                }
        
                function inputValidation() {
                    const numberOfSamples = parseInt(document.getElementById('samples').value);
                    if (isNaN(numberOfSamples) || numberOfSamples <= 0) {
                        alert('Veuillez entrer un nombre valide d\'échantillons.');
                        return false;
                    }
                    return true;
                }
        
                function setPoints() {
                    if (!inputValidation()) return;
                    currentD = parseInt(document.getElementById('dimension').value);
                    currentN = parseInt(document.getElementById('samples').value);
                    currentPoints = points(currentD, currentN);
                }
        
                function refresh() {
                    if (!inputValidation() || !currentPoints) return;
                    // Afficher le message "Veuillez patienter"
                    document.getElementById('loadingMessage').style.display = 'block';
                    // Générer l'hypercube
                    setTimeout(() => {
                        const convexHull = document.querySelector('input[name="convexHull"]:checked').value;
                        scatter(currentD, currentPoints, currentD * currentD, convexHull);
                        // Masquer le message
                        document.getElementById('loadingMessage').style.display = 'none';
                    }, 100);
                }
        
                document.querySelectorAll('input[name="NormalVector"]').forEach(input => {
                    input.addEventListener('change', () => {
                        updateInputs();
                        setPoints();
                    });
                });
        
                document.getElementById('dimension').addEventListener('input', () => {
                    updateInputs();
                    setPoints();
                });
                document.addEventListener('keydown', function(event) {
                    if (event.key === 'Enter') {
                        refresh();
                    }
                });
        
                document.getElementById('samples').addEventListener('input', setPoints);
                document.getElementById('refreshButton').addEventListener('click', refresh);
        
                setPoints();
                updateInputs();
            });
        </script>
        </body>
        </html>



    </section>

    <section class="res" id="res">
        <h2 class="section-title">Resources</h2>
            <h1 class="text">Hypercube Projection</h1>
        
            <h2 class="text">Random Points Generation</h2>
            <p class="text">
                We randomly sample \( N \) points \( x_i \) inside \( C \) :
                \( x_i = 2 \times \text{rand}() - 1 \) (as \(\text{rand}() \in [0,1]\))
                \( i = 1, \ldots, N \) \( j = 1, \ldots, D \) (for each dimension of \( C \) we have a random coordinate of point \( x_i \))
            </p>
        
            <h2 class="text">Plane Construction</h2>
            <p class="text">
                We define the plane by its normal vector \( \mathbf{w} \) (by default randomly chosen: \( w_j = \text{rand()} \) with \( j = 1, \ldots, D \)).
                Then we construct the projection plane using the Gram-Schmidt process (algorithm used in linear algebra to find an orthogonal base from a set of linearly independent vectors) :
                <ul>
                    <li>Normalization of \( \mathbf{w} \) : \( \mathbf{w} = \frac{\mathbf{w}}{\| \mathbf{w} \|} \)</li>
                    <li>Initialization of vectors \( \mathbf{e}_1 \) and \( \mathbf{e}_2 \) : \( e_{1j} = \text{rand()} \) ; \( e_{2j} = \text{rand()} \) with \( j = 1, \ldots, D \)</li>
                    <li>Gram-Schmidt :
                        <ul>
                            <li>\( \mathbf{e}_1 = \mathbf{e}_1 - \langle \mathbf{e}_1, \mathbf{w} \rangle \mathbf{w} \) &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp(for \( \mathbf{e}_1 \perp \mathbf{w} \))</li>
                            <li>\( \mathbf{e}_1 = \frac{\mathbf{e}_1}{\| \mathbf{e}_1 \|} \)</li>
                            <li>\( \mathbf{e}_2 = \mathbf{e}_2 - \langle \mathbf{e}_2, \mathbf{w} \rangle \mathbf{w} \) &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp(for \( \mathbf{e}_2 \perp \mathbf{w} \))</li>
                            <li>\( \mathbf{e}_2 = \mathbf{e}_2 - \langle \mathbf{e}_2, \mathbf{e}_1 \rangle \mathbf{e}_1 \) &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp(for \( \mathbf{e}_2 \perp \mathbf{e}_1 \))</li>
                            <li>\( \mathbf{e}_2 = \frac{\mathbf{e}_2}{\| \mathbf{e}_2 \|} \)</li>
                        </ul>
                    </li>
                </ul>
                Thus, we obtain the coordinates of each point \( \mathbf{y}_i \) projection of \( \mathbf{x}_i \) onto the plane (\( \mathbf{e}_1, \mathbf{e}_2 \)) :
                \( y_{i1} = \langle \mathbf{x}_i, \mathbf{e}_1 \rangle \)
                \( y_{i2} = \langle \mathbf{x}_i, \mathbf{e}_2 \rangle \)
            </p>
        
            <h2 class="text">Cube Corners</h2>
            <p class="text">
                A corner of the hypercube is a vector \( \mathbf{a}_i = [\alpha_1, \ldots, \alpha_D] \) with \( \alpha_j \in [-1, 1] \)
                we can project this corner onto 
                <div id="vector-column">
                    \[
                    \mathbf{z_i} = \begin{bmatrix} z_{i1}=\langle a_i, e_1 \rangle \\ z_{i2}=\langle a_i, e_2 \rangle \end{bmatrix}
                    \]
                </div>
                <p class="text">The number of corners of the \( D \)-dimensional hypercube will be \( 2^D \)</p>
            </p>
        
            <h2 class="text">Inscribed and Circumscribed Spheres</h2>
            <p class="text">
                As by definition \( O \in (P) \), we can trace the projection of the inscribed sphere as the circle of radius 1, so the corners of the hypercube will be well outside this sphere.
                Furthermore, we have that the norm of any corner \( \mathbf{a}_i \), \( \| \mathbf{a}_i \| = \sqrt{D} \)
                so the projection of the circumscribed sphere will be the circle of radius \( \sqrt{D} \)
            </p>
        
            <h2 class="text">Projection Coordinates Statistics</h2>
            <p class="text">
                We plotted the histogram of <b>\( \bar{y}_{i1} \)</b> and <b>\( \bar{y}_{i2} \)</b>, found in the "construction of the plane" section.
            </p>
            <P class="text">
                The expected outcome is a Gaussian distribution where the mean \( \bar{y}_i \) increases with  \( D \) and the ratio <b>\( \frac{\text{Var}(y_i)}{\bar{y}_i} \)</b> tends towards 0.
            </p>
            

            
        </section>


    <footer id="end">
        <p class="copyright">&copy; 2024-Curse of Dimensionality</p>
        <a href="" class="more">more</a>
    </footer>


    
    
    <script src="../JavaScript/Smooth_web_page.js"></script>

</body>
</html>

